/* AMX Mod script.
*
* (c) 2003, OLO
* This file is provided as is (no warranties).
*
* Admin command:
* amx_statscfg - displays menu with configuration
*/

#include <amxmod>
#include <amxmisc>

#define MAX_MENU_DATA 64

new g_menuData[MAX_MENU_DATA][32]
new g_menuDataMisc[MAX_MENU_DATA][2]
new g_menuDataNum
new g_menuPosition[33]
new bool:g_modified

new filetosave[] = "addons/amx/stats.ini"

public plugin_precache(){
  register_clcmd("amx_statscfg","cmdCfgMenu",ADMIN_CFG,"- displays stats configuration")
  register_srvcmd("amx_addoption","setCfgMenu")
  for(new a = 5; a < 10; ++a) 
    remove_user_flags(0,-1,a)
}

public plugin_init() {
  register_plugin("Stats Settings","0.9.4","default")
  register_menucmd(register_menuid("\yStats Settings"),1023,"actionCfgMenu")
  loadSettings(filetosave)
}

public setCfgMenu(){
  if ( read_argc() < 4 || g_menuDataNum >= MAX_MENU_DATA  ) 
    return PLUGIN_HANDLED
  new szTemp[6]
  read_argv(1, g_menuData[g_menuDataNum] ,31)
  read_argv(2,szTemp,5)
  g_menuDataMisc[ g_menuDataNum ][ 0 ] = strtonum(szTemp) 
  read_argv(3,szTemp,5)
  g_menuDataMisc[ g_menuDataNum ][ 1 ] = strtonum(szTemp)
  g_menuDataNum++
  return PLUGIN_HANDLED
}

public cmdCfgMenu(id,level,cid){
  if (cmd_access(id,level,cid,1))
    displayCfgMenu(id,g_menuPosition[id] = 0)
  return PLUGIN_HANDLED
}

displayCfgMenu(id,pos){
  if (pos < 0) return
  new menu_body[512], start = pos * 7
  if (start >= g_menuDataNum) start = pos = g_menuPosition[id] = 0
  new len = format(menu_body,511,"\yStats Settings\R%d/%d^n\w^n",
    pos + 1,((g_menuDataNum/7)+((g_menuDataNum%7)?1:0)))
  new end = start + 7, keys = (1<<9)|(1<<7), k = 0
  if (end > g_menuDataNum) end = g_menuDataNum
  for(new a = start; a < end; ++a){
    keys |= (1<<k)
    len += format(menu_body[len],511-len,"%d. %s\y\R%s^n\w",++k,
      g_menuData[a], (get_user_flags(0,g_menuDataMisc[a][0]) & (1<<g_menuDataMisc[a][1]) ) ? "ON" : "OFF")
  }
  
  if ( g_menuDataNum == 0 )
    len += format(menu_body[len],511-len,"\dStats plugins are not^ninstalled on this server^n\w")
  
  len += format(menu_body[len],511-len,"^n8. Save settings \y\R%s^n\w",g_modified ? "*" : "")
  if (end != g_menuDataNum){
    len += format(menu_body[len],511-len,"^n9. More...^n0. %s", pos ? "Back" : "Exit")
    keys |= (1<<8)
  }
  else {
    len += format(menu_body[len],511-len,"^n0. %s", pos ? "Back" : "Exit")
  }
  show_menu(id,keys,menu_body)
}

public actionCfgMenu(id,key){
  switch(key){
  case 7:{
      if (saveSettings(filetosave)){
        g_modified = false
        client_print(id,print_chat,"* Configuration saved successfully")
      }
      else
        client_print(id,print_chat,"* Configuration saving failed!!!")
      displayCfgMenu(id,g_menuPosition[id])
    }
  case 8: displayCfgMenu(id,++g_menuPosition[id])
  case 9: displayCfgMenu(id,--g_menuPosition[id])
  default:{
      new option = g_menuPosition[id] * 7 + key
      new myflag =  (1 << (g_menuDataMisc[option][1]))
      new mychannel = g_menuDataMisc[option][0]
      g_modified = true
      if ( get_user_flags(0,mychannel ) & myflag )
        remove_user_flags(0,myflag,mychannel)
      else
        set_user_flags(0,myflag,mychannel)
      displayCfgMenu(id,g_menuPosition[id])
    }
  }
  return PLUGIN_HANDLED
}

saveSettings(filename[]){

  if (file_exists(filename))
    delete_file(filename)
    
  new text[256]
  
  if (!write_file(filename,";Generated by Stats Settings Plugin. Do not modify!^n;Channel  Flag  Description"))
    return 0
  
  for(new a = 0; a < g_menuDataNum; ++a)
  {
    if ((get_user_flags(0,g_menuDataMisc[a][0]) & (1<<g_menuDataMisc[a][1]) ))
    {
      format(text,255,"%d %d ;%s",g_menuDataMisc[a][0],g_menuDataMisc[a][1],g_menuData[a])
      write_file(filename,text)
    }
  }
  
  return 1
}

loadSettings(filename[])
{
  if (!file_exists(filename)) 
    return 0
    
  new text[256], channel[4], flag[4]
  new len, pos = 0
  
  while (read_file(filename,pos++,text,255,len))
  {
    if ( text[0] == ';' ) continue // line is a comment
    
    parse(text,channel,3,flag,3)
    set_user_flags(0,(1<<strtonum(flag)),strtonum(channel))
    
  }
  
  return 1
}